# [PredictionIO](http://prediction.io)

PredictionIO is an open source machine learning framework for developers and data scientists. It supports event collection, deployment of algorithms, evaluation, querying predictive results via REST APIs.

To get started, check out <http://prediction.io>!

## Table of contents
- [Installation](#installation)
- [Quick start](#quick-start)
- [Bugs and feature requests](#bugs-and-feature-requests)
- [Documentation](#documentation)
- [Contributing](#contributing)
- [Community](#community)


## Installation

Five installation options available.

* [Installing PredictionIO on Linux / Mac OS X](http://docs.prediction.io/install/install-linux/)
* [Installing PredictionIO from Source Code](http://docs.prediction.io/install/install-sourcecode/)
  If you are installing from source code, it's recommended that you clone the master branch.
* [Launching PredictionIO on AWS](http://docs.prediction.io/install/launch-aws/)
* [Installing PredictionIO with Docker](https://github.com/mingfang/docker-predictionio) (Community contributed)
* [Installing PredictionIO with Vagrant](http://docs.prediction.io/install/install-vagrant/)


## Quick start
[Recommendation Engine Template Quick Start](http://docs.prediction.io/templates/recommendation/quickstart/) Guide.

[Similiar Product Engine Template Quick Start](http://docs.prediction.io/templates/similarproduct/quickstart/) Guide.

[Classification Engine Template Quick Start](http://docs.prediction.io/templates/classification/quickstart/) Guide.

## Bugs and feature requests

Have a bug or a feature request?  Please search for existing and closed issues on the [Community Forum](https://groups.google.com/forum/#!forum/predictionio-user). If your problem or idea is not addressed yet, [please open a new issue](https://github.com/PredictionIO/PredictionIO/issues/new).


## Documentation

PredictionIO's documentation, included in this repo in the `docs/manual` directory, is built with [Middleman](http://middlemanapp.com/) and publicly hosted at [docs.prediction.io](http://docs.prediction.io/).

Interested in helping with our documentation? Read [Contributing Documentation](http://docs.prediction.io/community/contribute-documentation/).

[![Build Status](https://travis-ci.org/PredictionIO/PredictionIO.svg?branch=livedoc)](https://travis-ci.org/PredictionIO/PredictionIO) [![Dependency Status](https://gemnasium.com/PredictionIO/PredictionIO.svg)](https://gemnasium.com/PredictionIO/PredictionIO)

## Community

Keep track of development and community news.

- Follow [@predictionio](https://twitter.com/predictionio) on Twitter.
- Read and subscribe to [the Newsletter ](http://prediction.us6.list-manage1.com/subscribe?u=d8c0435d851c1310fc64c6e26&id=8c6c1b46d0).
- Join the [Community Forum](https://groups.google.com/forum/#!forum/predictionio-user).


## Contributing

Please read and sign the [Contributor Agreement](http://prediction.io/cla). If you have any questions, you can post on the [Contributor Forum](https://groups.google.com/forum/#!forum/predictionio-dev).

You can also list your projects on the [Community Project page](http://docs.prediction.io/community/projects/)

## License
PredictionIO is under [Apache 2 license](http://www.apache.org/licenses/LICENSE-2.0.html).
